
; Public Domain

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

	cpu 8086

	addsection RELOCATEDDATA, nobits vstart=8000h
relocateddata:

	addsection HEADER, start=0

		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
	iend


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
code_start:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "SET"
	iend


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%define DATAFIXUP - datastart + 0
datastart:


	usesection CODE

command:
	jmp strict short .entry
.chain:
	extcall cmd3_not_ext		; must NOT be extcallcall
	times 10 - ($ - command) nop
.entry:
	push si
	cmp al, '-'
	jne @F
	extcallcall skipcomma
@@:
	dec si

	mov dx, msg.set
internaldatarelocation
	extcallcall isstring?
	je @F
.not_set:
	pop si
	dec si
	lodsb
	jmp .chain

@@:
.ours:
	pop ax
	extcallcall skipcomma
	dec si
	push si
	mov dx, relocateddata
linkdatarelocation msg.uninstall
	extcallcall isstring?
	jne @F
	extcallcall skipwhite
	extcallcall iseol?
	jne @F
	pop ax
	jmp uninstall
@@:
	pop si
	lodsb
run:
	extcallcall iseol?
	je showall
	dec si
	mov bx, si
@@:
	lodsb
	cmp al, '='
	je set_or_clear
	extcallcall iseol?.notsemicolon
	jne @B
showone:
	dec si
	mov cx, si
	sub cx, bx
	jz error
	mov si, bx
	push cx
	mov di, relocateddata
linkdatarelocation line_out
	push di
@@:
	lodsb
	extcallcall uppercase
	stosb
	loop @B
	mov al, '='
	stosb
	pop si
	pop cx
	inc cx

	call get_env
	extcallcall setes2dx
	xor di, di
	houdini
.loop:
	mov al, 0
	scasb
	je .end
	dec di
	push di
	push si
	push cx
@@:
	repe cmpsb
	je @F
	mov al, [es:di - 1]
	extcallcall uppercase
	cmp al, [si - 1]
	je @B
@@:
	mov dx, di
	pop cx
	pop si
	pop di
	je .found
	push cx
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	pop cx
	je .loop
.end:
	push ss
	pop es
	mov dx, msg.notfound.1
internaldatarelocation
	extcallcall putsz
	mov dx, bx
	dec cx
	extcallcall puts
	mov dx, msg.notfound.2
internaldatarelocation
	extcallcall putsz
	extcallcall cmd3


.found:
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	mov cx, di
	dec cx
	sub cx, dx
	extcallcall puts
	mov dx, msg.crlf
internaldatarelocation
	extcallcall putsz
	extcallcall cmd3


set_or_clear:
	push si
	lodsb
	extcallcall iseol?.notsemicolon
	je clear
@@:
	lodsb
	extcallcall iseol?.notsemicolon
	jne @B
set:
	dec si
	mov dx, si			; -> EOL
	pop si
	dec si
	mov cx, si
	sub cx, bx
	jz error
	mov si, bx
	push cx
	mov di, relocateddata
linkdatarelocation line_out
	push di
@@:
	lodsb
	extcallcall uppercase
	stosb
	loop @B
	mov al, '='
	stosb
	pop si
	pop cx
	inc cx

	add bx, cx

	lframe none
	lvar word, offsettoinsert
	lenter
	lvar word, pointercontent
	 push bx
	lvar word, pointereol
	 push dx
	lvar word, pointername
	 push si
	lvar word, lengthname
	 push cx
	xor dx, dx
	lvar word, lengthtofree
	 push dx
	lvar word, offsettofree
	 push dx
	call get_env
	dec dx
	extcallcall setes2dx
	lvar word, envsizepara
	 push word [es:3]
	inc dx
	extcallcall setes2dx
	xor di, di
	houdini
.loop:
	mov al, 0
	scasb
	je .end
	dec di
	push di
	push si
	push cx
@@:
	repe cmpsb
	je @F
	mov al, [es:di - 1]
	extcallcall uppercase
	cmp al, [si - 1]
	je @B
@@:
	pop cx
	pop si
	pop di
	je .found
	push cx
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	pop cx
	je .loop
.error:
	mov dx, msg.error_invalid
internaldatarelocation
	extcallcall putsz
	extcallcall cmd3

.full:
	mov dx, msg.error_full
internaldatarelocation
	extcallcall putsz
	extcallcall cmd3


.found:
	mov si, di		; si -> at the variable
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	jne .error
				; di -> after NUL
	mov dx, di
	sub dx, si
	mov word [bp + ?lengthtofree], dx
	mov word [bp + ?offsettofree], si

.loop_find_length:
	mov al, 0
	scasb
	je .end
	dec di
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	je .loop_find_length
	jmp .error


.end:
	lea ax, [di - 1]
	mov word [bp + ?offsettoinsert], ax
	mov ax, 1
	scasw			; cmp ax, [es:di]
	jb .error		; 1 < word, unknown -->
	ja .havesize		; 1 > word, no additional string -->
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	jne .error
.havesize:
	mov cx, di		; length total
	sub cx, word [bp + ?lengthtofree]
				; length when freeing prior
	mov ax, word [bp + ?pointereol]
	sub ax, word [bp + ?pointercontent]
				; length content
	lvar word, lengthcontent
	 push ax
	add ax, word [bp + ?lengthname]
				; length name
	inc ax			; length insert
	lvar word, lengthinsert
	 push ax
	add cx, ax
	jc .full
	mov dx, word [bp + ?envsizepara]
	add dx, dx
	jc @F
	add dx, dx
	jc @F
	add dx, dx
	jc @F
	add dx, dx
	jnc @FF
@@:
	mov dx, -1
@@:
	cmp dx, cx
	jb .full

	lvar word, offsetend
	 push di
	mov cx, di			; -> end
	mov di, word [bp + ?offsettofree]
					; -> to free (destination)
	mov si, di
	add si, word [bp + ?lengthtofree]
					; -> source
	sub cx, si			; = end minus source = how long
	 push es
	 pop ds
	rep movsb			; di -> new end
	dec di				; -> new last byte
	mov si, di			; si -> new last byte
	add di, word [bp + ?lengthinsert]
					; di -> destination last byte
	mov cx, word [bp + ?offsettoinsert]
	sub cx, word [bp + ?lengthtofree]
					; cx -> where to insert
	push cx
	neg cx
	add cx, si			; last byte minus where to insert
	inc cx

	std
	numdef AMD_ERRATUM_109_WORKAROUND, 1
%if _AMD_ERRATUM_109_WORKAROUND
	jcxz @FF
	cmp cx, 20
	ja @FF
@@:
	movsb
	loop @B
@@:
%endif
	rep movsb
	cld

	pop di
	 push ss
	 pop ds
	mov si, word [bp + ?pointername]
	mov cx, word [bp + ?lengthname]
	rep movsb
	mov si, word [bp + ?pointercontent]
	mov cx, word [bp + ?lengthcontent]
	rep movsb
	mov al, 0
	stosb
	extcallcall cmd3
	lleave ctx


clear:
	pop si
	dec si
	mov cx, si
	sub cx, bx
	jz error
	mov si, bx
	push cx
	mov di, relocateddata
linkdatarelocation line_out
	push di
@@:
	lodsb
	extcallcall uppercase
	stosb
	loop @B
	mov al, '='
	stosb
	pop si
	pop cx
	inc cx

	call get_env
	dec dx
	extcallcall setes2dx
	mov bp, word [es:3]
	inc dx
	extcallcall setes2dx
	xor di, di
	houdini
.loop:
	mov al, 0
	scasb
	je .end
	dec di
	push di
	push si
	push cx
@@:
	repe cmpsb
	je @F
	mov al, [es:di - 1]
	extcallcall uppercase
	cmp al, [si - 1]
	je @B
@@:
	pop cx
	pop si
	pop di
	je .found
	push cx
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	pop cx
	je .loop
.end:
	extcallcall cmd3

.found:
	mov si, di		; si -> at the variable
	mov al, 0
	mov cx, 7FFFh
	repne scasb
	jne .end
				; di -> after NUL
	xchg si, di		; di -> variable, si -> after NUL
	mov cx, bp
	add cx, cx
	jc @F
	add cx, cx
	jc @F
	add cx, cx
	jc @F
	add cx, cx
	jnc @FF
@@:
	mov cx, -1
@@:
	sub cx, si
	push es
	pop ds
	rep movsb
	jmp .end


showall:
	call get_env
	extcallcall setes2dx
	xor di, di
.loop:
	mov dx, di
	mov al, 0
	scasb
	je .end
	mov cx, 7FFFh
	repne scasb
	jne .end
	mov cx, di
	dec cx
	sub cx, dx
	extcallcall puts
	mov dx, msg.crlf
internaldatarelocation
	extcallcall putsz
	jmp .loop

.end:
	extcallcall cmd3


get_env:
	mov dx, [2Ch]
	test dx, dx
	jz @F
	retn

@@:
	mov dx, msg.error
internaldatarelocation
	extcallcall putsz
	extcallcall cmd3


uninstall:
	mov es, word [relocateddata]
linkdatarelocation extdssel
	extcallcall ispm
	jz @F
	mov es, word [relocateddata]
linkdatarelocation extseg
@@:
	push es
	pop ds
	xor bx, bx		; = 0 (no prior, modify ext_command_handler)
	mov di, command		; di -> us
internalcoderelocation
	mov si, word [ss:relocateddata]
linkdatarelocation ext_command_handler
				; si -> first
	test si, si		; none installed ?
	jz .error		; error -->

.loop:
	cmp di, si		; found ?
	je .bx			; yes, use bx -->
	mov bx, si		; bx -> prior handler
	lodsw			; skip entrypoint jmp strict short
	lodsb			; get first byte of chainer
	cmp al, 0E9h		; expecting jmp near ?
	jne .error		; no, error -->
	lodsw			; get rel16 displacement
	add si, ax		; -> next handler
	jmp .loop

.bx:
	test bx, bx		; any prior ?
	jnz .bxnz		; yes -->
	scasw			; skip entrypoint jmp strict short
	cmp byte [di], 0E8h	; is it a call to cmd3_not_ext ?
	jne @F			; no -->
				; yes, reset ext_command_handler to zero
.setbx:
	mov word [ss:relocateddata], bx
linkdatarelocation ext_command_handler
	jmp .done

@@:
	cmp byte [di], 0E9h	; validate
	jne .error		; failure -->
	inc di			; -> rel16 displacement
	mov bx, word [di]	; get displacement
	scasw			; -> after jmp near
	add bx, di		; -> next handler
	jmp .setbx		; set ext_command_handler to next

.bxnz:
	mov si, bx		; -> prior handler with us as downlink
	xchg di, si		; si -> ours, di -> prior
	cmpsw			; skip entrypoint jmp strict short
	movsb			; copy 0E8h/0E9h
	lodsw			; ax = near rel16 displacement
	add ax, si		; add in our base (= absolute offset)
	sub ax, di
	dec ax
	dec ax			; subtract new base (= relative displacement)
	stosw			; store new rel16 displacement
	movsw			; jmp strict short
	movsw			; linkcall target
	movsb			; trailer
.done:
	clropt [code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as free
	mov dx, msg.uninstall_done
internaldatarelocation
@@:
	push ss
	pop ds
	extcallcall putsz
	extcallcall cmd3	; return

.error:
	mov dx, msg.uninstall_error
internaldatarelocation
	jmp @B


error:
	extcall error

	eldcall_dump_callcall ELDCALL_CALLCALL_LIST

endinstalled equ ($ + CODEFIXUP + 15) & ~15


start:
	mov bx, es
	 push ss
	 pop es

	call skipcomma
	dec si
	mov dx, relocateddata
linkdatarelocation msg.install
	call isstring?
	je install
	mov dx, relocateddata
linkdatarelocation msg.run
	call isstring?
	jne help
	extcall skipcomma
	jmp run

help:
	mov dx, msg.help
internaldatarelocation
	extcall putsz
	call uninstall_oneshot
	xor ax, ax
	retf


uninstall_oneshot:
	testopt [ss:relocateddata], 1
linkdatarelocation options7, -3
	jnz @F

	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used

	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extdata_used
@@:
	retn


install:
	lodsb
	extcall chkeol

	houdini
	mov es, bx		; => ext seg (writable)
	mov ax, endresident - endinstalled
	sub word [es:code + eldiEndCode], ax
internalcoderelocation		; adjust size
	sub word [relocateddata], ax
linkdatarelocation extseg_used	; adjust size
	mov bx, word [relocateddata]
linkdatarelocation ext_command_handler
				; -> prior
	mov di, command		; -> our handler
internalcoderelocation
	test bx, bx		; installing as first ?
	jz .only_first		; yes, simple --> (leave as extcall cmd3_not_ext)
	scasw			; skip entrypoint jmp strict short
	mov al, 0E9h		; = jmp near opcode
	stosb			; store
	xchg ax, bx		; ax -> next handler
	sub ax, di
	dec ax
	dec ax			; ax = ax - (di + 2)
	stosw			; store our downlink as rel16 displacement

.only_first:
	setopt [es:code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as resident
	mov word [relocateddata], command
linkdatarelocation ext_command_handler, -4
internalcoderelocation		; -> our entrypoint

	testopt [relocateddata], 4
linkdatarelocation options7, -3
	jnz @F
	mov dx, msg.installed
internaldatarelocation
	call putsz
@@:
	xor ax, ax
	retf


	usesection DATA
msg:
.set:			asciz "SET"
.notfound.1:		asciz "Environment variable '"
.notfound.2:		asciz "' not found.",13,10
.uninstall_done:	asciz "SET command uninstalled. (Don't forget to use reclaim.eld)",13,10
.uninstall_error:	asciz "SET command unable to uninstall!",13,10
.error:			db "SET command error: No environment!"
.crlf:			asciz 13,10
.error_full:		asciz "Environment full.",13,10
.error_invalid:		asciz "Environment invalid.",13,10

uinit_data: equ $

.installed:	asciz "SET command installed.",13,10
.help:		db "Install this ELD using the INSTALL keyword parameter.",13,10
		db 13,10
		db "Run as SET variable=content to set a variable.",13,10
		db "Run as SET variable= to delete a variable.",13,10
		db "Run as SET variable to display a variable.",13,10
		db "Run as SET to display all variables.",13,10
		db "Run as SET UNINSTALL to uninstall this ELD.",13,10
		asciz

	align 16, db 0
init_data_end:
data_size equ $ - datastart

	absolute uinit_data

	alignb 16
uinit_data_end:
resident_data_end:

%if uinit_data_end >= init_data_end
 total_data_size equ $ - datastart
%else
 total_data_size equ init_data_end - datastart
%endif
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
